package org.jboss.security.ssl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.IOException;
import java.io.Serializable;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import javax.net.SocketFactory;
import javax.net.ssl.HandshakeCompletedEvent;
import javax.net.ssl.HandshakeCompletedListener;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import org.jboss.logging.Logger;

public class ClientSocketFactory extends SocketFactory implements HandshakeCompletedListener, Serializable {
  static final long serialVersionUID = -2762336418317218104L;
  
  public Socket createSocket(String serverHost, int serverPort) throws IOException, UnknownHostException {
    InetAddress serverAddr = InetAddress.getByName(serverHost);
    return createSocket(serverAddr, serverPort);
  }
  
  public Socket createSocket(String serverHost, int serverPort, InetAddress clientAddr, int clientPort) throws IOException, UnknownHostException {
    InetAddress serverAddr = InetAddress.getByName(serverHost);
    return createSocket(serverAddr, serverPort, clientAddr, clientPort);
  }
  
  public Socket createSocket(InetAddress serverAddr, int serverPort) throws IOException {
    return createSocket(serverAddr, serverPort, null, 0);
  }
  
  public Socket createSocket(InetAddress serverAddr, int serverPort, InetAddress clientAddr, int clientPort) throws IOException {
    SSLSocketFactory factory = (SSLSocketFactory)SSLSocketFactory.getDefault();
    SSLSocket socket = (SSLSocket)factory.createSocket(serverAddr, serverPort, clientAddr, clientPort);
    socket.addHandshakeCompletedListener(this);
    return socket;
  }
  
  public boolean equals(Object obj) {
    return obj instanceof org.jboss.security.ssl.ClientSocketFactory;
  }
  
  public int hashCode() {
    return getClass().getName().hashCode();
  }
  
  public void handshakeCompleted(HandshakeCompletedEvent handshakeCompletedEvent) {
    Logger log = Logger.getLogger(org.jboss.security.ssl.ClientSocketFactory.class);
    if (log.isTraceEnabled()) {
      String cipher = handshakeCompletedEvent.getCipherSuite();
      SSLSession session = handshakeCompletedEvent.getSession();
      String peerHost = session.getPeerHost();
      log.debug("SSL handshakeCompleted, cipher=" + cipher + ", peerHost=" + peerHost);
    } 
  }
}
